package l1j.william;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.StringTokenizer;
import l1j.server.L1DatabaseFactory;
import l1j.server.Server;
import l1j.server.server.datatables.ItemTable;
import l1j.server.server.model.L1Quest;
import l1j.server.server.model.Instance.L1ItemInstance;
import l1j.server.server.model.Instance.L1NpcInstance;
import l1j.server.server.model.Instance.L1PcInstance;
import l1j.server.server.serverpackets.S_NPCTalkReturn;
import l1j.server.server.serverpackets.S_ServerMessage;
import l1j.server.server.templates.L1Item;
import l1j.server.server.world.L1World;

public class NpcQuest {

   private static ArrayList aData = new ArrayList();
   private static boolean NO_GET_DATA = false;
   public static final String TOKEN = ",";


   public static void main(String[] a) {
      while(true) {
         try {
            Server.main((String[])null);
         } catch (Exception var2) {
            ;
         }
      }
   }

   public static boolean forNpcQuest(String s, L1PcInstance pc, L1NpcInstance npc, int npcid, int oid) {
      ArrayList aTempData = null;
      if(!NO_GET_DATA) {
         NO_GET_DATA = true;
         getData();
      }

      L1Quest quest = pc.getQuest();
      byte class_id = 0;
      if(pc.isCrown()) {
         class_id = 1;
      } else if(pc.isKnight()) {
         class_id = 2;
      } else if(pc.isWizard()) {
         class_id = 3;
      } else if(pc.isElf()) {
         class_id = 4;
      } else if(pc.isDarkelf()) {
         class_id = 5;
      }

      for(int i = 0; i < aData.size(); ++i) {
         aTempData = (ArrayList)aData.get(i);
         if(aTempData.get(0) != null && ((Integer)aTempData.get(0)).intValue() == npcid && ((String)aTempData.get(1)).equals(s) && (((Integer)aTempData.get(2)).intValue() != 0 && pc.getLevel() >= ((Integer)aTempData.get(2)).intValue() || ((Integer)aTempData.get(2)).intValue() == 0) && (((Integer)aTempData.get(3)).intValue() != 0 && ((Integer)aTempData.get(3)).intValue() == class_id || ((Integer)aTempData.get(3)).intValue() == 0) && (((Integer)aTempData.get(4)).intValue() != 0 && pc.getTempCharGfx() == ((Integer)aTempData.get(4)).intValue() || ((Integer)aTempData.get(4)).intValue() == 0) && (((Integer)aTempData.get(5)).intValue() != 0 && quest.get_step(((Integer)aTempData.get(5)).intValue()) == ((Integer)aTempData.get(6)).intValue() || ((Integer)aTempData.get(5)).intValue() == 0) && (((Integer)aTempData.get(7)).intValue() != 0 && quest.get_step(((Integer)aTempData.get(7)).intValue()) != ((Integer)aTempData.get(8)).intValue() || ((Integer)aTempData.get(7)).intValue() == 0) && ((int[])((int[])aTempData.get(11)) != null && (int[])((int[])aTempData.get(12)) != null && !pc.getInventory().checkItem((int[])((int[])aTempData.get(11)), (int[])((int[])aTempData.get(12))) || (int[])((int[])aTempData.get(11)) == null && (int[])((int[])aTempData.get(12)) == null) && ((int[])((int[])aTempData.get(9)) != null && (int[])((int[])aTempData.get(10)) != null && pc.getInventory().checkItem((int[])((int[])aTempData.get(9)), (int[])((int[])aTempData.get(10))) || (int[])((int[])aTempData.get(9)) == null && (int[])((int[])aTempData.get(10)) == null)) {
            boolean isGet = false;
            boolean isCreate = true;
            int[] giveMaterials;
            int[] giveCounts;
            int l;
            if((int[])((int[])aTempData.get(13)) != null && (int[])((int[])aTempData.get(14)) != null) {
               giveMaterials = (int[])((int[])aTempData.get(13));
               giveCounts = (int[])((int[])aTempData.get(14));

               for(l = 0; l < giveMaterials.length; ++l) {
                  if(!pc.getInventory().checkItem(giveMaterials[l], (long)giveCounts[l])) {
                     L1Item item = ItemTable.getInstance().getTemplate(giveMaterials[l]);
                     pc.sendPackets(new S_ServerMessage(337, item.getName() + "(" + ((long)giveCounts[l] - pc.getInventory().countItems(item.getItemId())) + ")"));
                     isCreate = false;
                  }
               }

               if(!isCreate) {
                  if((String[])((String[])aTempData.get(23)) != null) {
                     pc.sendPackets(new S_NPCTalkReturn(oid, (String)aTempData.get(22), (String[])((String[])aTempData.get(23))));
                  } else if(aTempData.get(22) != null) {
                     pc.sendPackets(new S_NPCTalkReturn(oid, (String)aTempData.get(22)));
                  }

                  return true;
               }

               if(isCreate && ((Integer)aTempData.get(15)).intValue() == 0) {
                  for(l = 0; l < giveMaterials.length; ++l) {
                     pc.getInventory().consumeItem(giveMaterials[l], (long)giveCounts[l]);
                  }
               }
            }

            if(((Integer)aTempData.get(15)).intValue() == 0 && (int[])((int[])aTempData.get(16)) != null && (int[])((int[])aTempData.get(17)) != null) {
               giveMaterials = (int[])((int[])aTempData.get(16));
               giveCounts = (int[])((int[])aTempData.get(17));

               for(l = 0; l < giveMaterials.length; ++l) {
                  L1ItemInstance var15 = ItemTable.getInstance().createItem(giveMaterials[l]);
                  if(var15.isStackable()) {
                     var15.setCount((long)giveCounts[l]);
                  } else {
                     var15.setCount(1L);
                  }

                  if(var15 != null) {
                     isGet = true;
                     if(pc.getInventory().checkAddItem(var15, (long)giveCounts[l]) == 0) {
                        pc.getInventory().storeItem(var15);
                     } else {
                        L1World.getInstance().getInventory(pc.getX(), pc.getY(), pc.getMapId()).storeItem(var15);
                     }

                     pc.sendPackets(new S_ServerMessage(143, npc.getNpcTemplate().get_name(), var15.getLogName()));
                  }
               }
            }

            if(((Integer)aTempData.get(18)).intValue() != 0 && ((Integer)aTempData.get(19)).intValue() != 0 && (isGet || isCreate)) {
               pc.getQuest().set_step(((Integer)aTempData.get(18)).intValue(), ((Integer)aTempData.get(19)).intValue());
            }

            if((String[])((String[])aTempData.get(21)) != null && (isGet || isCreate)) {
               pc.sendPackets(new S_NPCTalkReturn(oid, (String)aTempData.get(20), (String[])((String[])aTempData.get(21))));
               return true;
            } else if(aTempData.get(20) != null && (isGet || isCreate)) {
               pc.sendPackets(new S_NPCTalkReturn(oid, (String)aTempData.get(20)));
               return true;
            } else {
               pc.sendPackets(new S_NPCTalkReturn(oid, ""));
               return true;
            }
         }
      }

      return false;
   }

   private static void getData() {
      Connection con = null;

      try {
         con = L1DatabaseFactory.getInstance().getConnection();
         Statement stat = con.createStatement();
         ResultSet rset = stat.executeQuery("SELECT * FROM william_npc_quest");
         ArrayList aReturn = null;
         String sTemp = null;
         if(rset != null) {
            for(; rset.next(); aData.add(aReturn)) {
               aReturn = new ArrayList();
               aReturn.add(0, new Integer(rset.getInt("npcid")));
               sTemp = rset.getString("action");
               aReturn.add(1, sTemp);
               aReturn.add(2, new Integer(rset.getInt("checkLevel")));
               aReturn.add(3, new Integer(rset.getInt("checkClass")));
               aReturn.add(4, new Integer(rset.getInt("checkPoly")));
               aReturn.add(5, new Integer(rset.getInt("checkHaveQuestId")));
               aReturn.add(6, new Integer(rset.getInt("checkHaveQuestOrder")));
               aReturn.add(7, new Integer(rset.getInt("notHaveQuestId")));
               aReturn.add(8, new Integer(rset.getInt("notHaveQuestOrder")));
               if(rset.getString("checkItem") != null && !rset.getString("checkItem").equals("") && !rset.getString("checkItem").equals("0")) {
                  aReturn.add(9, getArray(rset.getString("checkItem"), ",", 1));
               } else {
                  aReturn.add(9, (Object)null);
               }

               if(rset.getString("checkItemCount") != null && !rset.getString("checkItemCount").equals("") && !rset.getString("checkItemCount").equals("0")) {
                  aReturn.add(10, getArray(rset.getString("checkItemCount"), ",", 1));
               } else {
                  aReturn.add(10, (Object)null);
               }

               if(rset.getString("notHaveItem") != null && !rset.getString("notHaveItem").equals("") && !rset.getString("notHaveItem").equals("0")) {
                  aReturn.add(11, getArray(rset.getString("notHaveItem"), ",", 1));
               } else {
                  aReturn.add(11, (Object)null);
               }

               if(rset.getString("notHaveItemCount") != null && !rset.getString("notHaveItemCount").equals("") && !rset.getString("notHaveItemCount").equals("0")) {
                  aReturn.add(12, getArray(rset.getString("notHaveItemCount"), ",", 1));
               } else {
                  aReturn.add(12, (Object)null);
               }

               if(rset.getString("material") != null && !rset.getString("material").equals("") && !rset.getString("material").equals("0")) {
                  aReturn.add(13, getArray(rset.getString("material"), ",", 1));
               } else {
                  aReturn.add(13, (Object)null);
               }

               if(rset.getString("materialCount") != null && !rset.getString("materialCount").equals("") && !rset.getString("materialCount").equals("0")) {
                  aReturn.add(14, getArray(rset.getString("materialCount"), ",", 1));
               } else {
                  aReturn.add(14, (Object)null);
               }

               aReturn.add(15, new Integer(rset.getInt("justCheckMaterial")));
               if(rset.getString("GiveItem") != null && !rset.getString("GiveItem").equals("") && !rset.getString("GiveItem").equals("0")) {
                  aReturn.add(16, getArray(rset.getString("GiveItem"), ",", 1));
               } else {
                  aReturn.add(16, (Object)null);
               }

               if(rset.getString("GiveItemCount") != null && !rset.getString("GiveItemCount").equals("") && !rset.getString("GiveItemCount").equals("0")) {
                  aReturn.add(17, getArray(rset.getString("GiveItemCount"), ",", 1));
               } else {
                  aReturn.add(17, (Object)null);
               }

               aReturn.add(18, new Integer(rset.getInt("saveQuestId")));
               aReturn.add(19, new Integer(rset.getInt("saveQuestOrder")));
               if(rset.getString("ShowHtml") != null && !rset.getString("ShowHtml").equals("")) {
                  aReturn.add(20, new String(rset.getString("ShowHtml")));
               } else {
                  aReturn.add(20, (Object)null);
               }

               if(rset.getString("ShowHtmlData") != null && !rset.getString("ShowHtmlData").equals("")) {
                  aReturn.add(21, getArray(rset.getString("ShowHtmlData"), ",", 2));
               } else {
                  aReturn.add(21, (Object)null);
               }

               if(rset.getString("ShowNotHaveHtml") != null && !rset.getString("ShowNotHaveHtml").equals("")) {
                  aReturn.add(22, new String(rset.getString("ShowNotHaveHtml")));
               } else {
                  aReturn.add(22, (Object)null);
               }

               if(rset.getString("ShowNotHaveHtmlData") != null && !rset.getString("ShowNotHaveHtmlData").equals("")) {
                  aReturn.add(23, getArray(rset.getString("ShowNotHaveHtmlData"), ",", 2));
               } else {
                  aReturn.add(23, (Object)null);
               }
            }
         }

         if(con != null && !con.isClosed()) {
            con.close();
         }
      } catch (Exception var5) {
         ;
      }

   }

   private static Object getArray(String s, String sToken, int iType) {
      StringTokenizer st = new StringTokenizer(s, sToken);
      int iSize = st.countTokens();
      String sTemp = null;
      int i;
      if(iType == 1) {
         int[] var9 = new int[iSize];

         for(i = 0; i < iSize; ++i) {
            sTemp = st.nextToken();
            var9[i] = Integer.parseInt(sTemp);
         }

         return var9;
      } else if(iType == 2) {
         String[] var8 = new String[iSize];

         for(i = 0; i < iSize; ++i) {
            sTemp = st.nextToken();
            var8[i] = sTemp;
         }

         return var8;
      } else if(iType != 3) {
         return null;
      } else {
         String sReturn = null;

         for(i = 0; i < iSize; ++i) {
            sTemp = st.nextToken();
            sReturn = sTemp;
         }

         return sReturn;
      }
   }

}
